/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Iconv.xs. Do not edit this file, edit Iconv.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Iconv.xs"
/* $Id: Iconv.xs,v 1.15 2007/10/17 14:06:22 mxp Exp $ */
/* XSUB for Perl module Text::Iconv                   */
/* Copyright (c) 2007 Michael Piotrowski              */

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <iconv.h>

/*****************************************************************************/
/* This struct represents a Text::Iconv object */

struct tiobj
{
   iconv_t handle;     /* iconv handle (returned by iconv_open()) */
   SV *retval;         /* iconv() return value (according to the Single UNIX
                          Specification, "the number of non-identical
                          conversions performed") */
   SV *raise_error;    /* Per-object flag controlling whether exceptions
                          are to be thrown */
};

/*****************************************************************************/

static int
not_here(s)
char *s;
{
   croak("%s not implemented on this architecture", s);
   return -1;
}

static int raise_error = 0;

/* Macro for checking when to throw an exception for use in the
   do_conv() function.  The logic is: Throw an exception IF
   obj->raise_error is undef AND raise_error is true OR IF
   obj->raise_error is true */
#define RAISE_ERROR_P (!SvOK(obj->raise_error) && raise_error) \
      || SvTRUE(obj->raise_error)

SV *do_conv(struct tiobj *obj, SV *string)
{
   char    *ibuf;         /* char* to the content of SV *string */
   char    *obuf;         /* temporary output buffer */
   size_t  inbytesleft;   /* no. of bytes left to convert; initially
                             this is the length of the input string,
                             and 0 when the conversion has finished */
   size_t  outbytesleft;  /* no. of bytes in the output buffer */
   size_t  l_obuf;        /* length of the output buffer */
   char    *icursor;      /* current position in the input buffer */
   /* The Single UNIX Specification (version 1 and version 2), as well
      as the HP-UX documentation from which the XPG iconv specs are
      derived, are unclear about the type of the second argument to
      iconv() (here called icursor): The manpages say const char **,
      while the header files say char **. */
   char    *ocursor;      /* current position in the output buffer */
   size_t  ret;           /* iconv() return value */
   SV      *perl_str;     /* Perl return string */

   /* Check if the input string is actually `defined'; otherwise
      simply return undef.  This is not considered an error. */

   if (! SvOK(string))
   {
      return(&PL_sv_undef);
   }
   
   perl_str = newSVpv("", 0);

   /* Get length of input string.  That's why we take an SV* instead
      of a char*: This way we can convert UCS-2 strings because we
      know their length. */

   inbytesleft = SvCUR(string);
   ibuf        = SvPV(string, inbytesleft);
   
   /* Calculate approximate amount of memory needed for the temporary
      output buffer and reserve the memory.  The idea is to choose it
      large enough from the beginning to reduce the number of copy
      operations when converting from a single-byte to a multibyte
      encoding. */
   
   if(inbytesleft <= MB_LEN_MAX)
   {
      outbytesleft = MB_LEN_MAX + 1;
   }
   else
   {
      outbytesleft = 2 * inbytesleft;
   }

   l_obuf = outbytesleft;

   New(0, obuf, outbytesleft, char); /* Perl malloc */
   if (obuf == NULL)
   {
      croak("New: %s", strerror(errno));
   }

   /**************************************************************************/

   icursor = ibuf;
   ocursor = obuf;

   /**************************************************************************/
   
   while(inbytesleft != 0)
   {
#if (defined(__hpux) || defined(__linux) || defined(VMS)) && ! defined(_LIBICONV_VERSION)
      /* Even in HP-UX 11.00, documentation and header files do not agree */
      /* glibc doesn't seem care too much about standards */
      ret = iconv(obj->handle, &icursor, &inbytesleft,
                                &ocursor, &outbytesleft);
#else
      ret = iconv(obj->handle, (const char **)&icursor, &inbytesleft,
                                &ocursor, &outbytesleft);
#endif

      if(ret == (size_t) -1)
      {
         obj->retval = &PL_sv_undef;

         switch(errno)
         {
            case EILSEQ:
               /* Stop conversion if input character encountered which
                  does not belong to the input char set */
               if (RAISE_ERROR_P)
                  croak("Character not from source char set: %s",
                        strerror(errno));
               Safefree(obuf);
               /* INIT_SHIFT_STATE(obj->handle, ocursor, outbytesleft); */
               return(&PL_sv_undef);
            case EINVAL:
               /* Stop conversion if we encounter an incomplete
                  character or shift sequence */
               if (RAISE_ERROR_P)
                  croak("Incomplete character or shift sequence: %s",
                        strerror(errno));
               Safefree(obuf);
               return(&PL_sv_undef);
            case E2BIG:
               /* fprintf(stdout, "%s\n", obuf); */

               /* If the output buffer is not large enough, copy the
                  converted bytes to the return string, reset the
                  output buffer and continue */
               sv_catpvn(perl_str, obuf, l_obuf - outbytesleft);
               ocursor = obuf;
               outbytesleft = l_obuf;
               break;
            default:
               if (RAISE_ERROR_P)
                  croak("iconv error: %s", strerror(errno));
               Safefree(obuf);
               return(&PL_sv_undef);
         }
      }
      else
      {
         obj->retval = newSViv(ret);
      }
   }

   /* For state-dependent encodings, place conversion descriptor into
      initial shift state and place the byte sequence to change the
      output buffer to its initial shift state.

      The only (documented) error for this use of iconv() is E2BIG;
      here it could happen only if the output buffer has no more room
      for the reset sequence.  We can simply prevent this case by
      copying its content to the return string before calling iconv()
      (just like when E2BIG happens during the "normal" use of
      iconv(), see above).  This adds the (slight, I'd guess) overhead
      of an additional call to sv_catpvn(), but it makes the code much
      cleaner.

      Note: Since we currently don't return incomplete conversion
      results in case of EINVAL and EILSEQ, we don't have to care
      about the shift state there.  If we did return the results in
      these cases, we'd also have to reset the shift state there.
   */

   sv_catpvn(perl_str, obuf, l_obuf - outbytesleft);
   ocursor = obuf;
   outbytesleft = l_obuf;

   if((ret = iconv(obj->handle, NULL, NULL, &ocursor, &outbytesleft))
      == (size_t) -1)
   {
      croak("iconv error (while trying to reset shift state): %s",
            strerror(errno));
      Safefree(obuf);
      return(&PL_sv_undef);
   }

   /* Copy the converted bytes to the return string, and free the
      output buffer */
   
   sv_catpvn(perl_str, obuf, l_obuf - outbytesleft);
   Safefree(obuf); /* Perl malloc */

   return perl_str;
}

/* */

#if _LIBICONV_VERSION >= 0x0109
int do_iconvctl(struct tiobj *obj, int request, void *arg)
{
   return iconvctl(obj->handle, request, arg);
}
#endif

typedef struct tiobj Text__Iconv;

/*****************************************************************************/
/* Perl interface                                                            */

#line 238 "Iconv.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 382 "Iconv.c"

XS_EUPXS(XS_Text__Iconv_raise_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Iconv_raise_error)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 235 "Iconv.xs"
      if (items > 0 && SvIOK(ST(0))) /* if called as function */
         raise_error = SvIV(ST(0));
      if (items > 1 && SvIOK(ST(1))) /* if called as class method */
         raise_error = SvIV(ST(1));
      RETVAL = raise_error;
#line 399 "Iconv.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Iconv_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Iconv_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, fromcode, tocode");
    {
	char *	fromcode = (char *)SvPV_nolen(ST(1))
;
	char *	tocode = (char *)SvPV_nolen(ST(2))
;
	Text__Iconv *	RETVAL;
#line 248 "Iconv.xs"
      iconv_t handle;
      Text__Iconv *obj;

      if ((handle = iconv_open(tocode, fromcode)) == (iconv_t)-1)
      {
         switch(errno)
         {
            case ENOMEM:
               croak("Insufficient memory to initialize conversion: %s", 
                     strerror(errno));
            case EINVAL:
               croak("Unsupported conversion from %s to %s: %s",
                     fromcode, tocode, strerror(errno));
            default:
               croak("Couldn't initialize conversion: %s", strerror(errno));
         }
      }

      Newz(0, obj, 1, Text__Iconv);
      if (obj == NULL)
      {
         croak("Newz: %s", strerror(errno));
      }

      obj->handle = handle;
      obj->retval = &PL_sv_undef;
      obj->raise_error = newSViv(0);
      sv_setsv(obj->raise_error, &PL_sv_undef);
      RETVAL = obj;
#line 449 "Iconv.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Text::IconvPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__IconvPtr_convert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_convert)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, string");
    {
	Text__Iconv *	self;
	SV *	string = ST(1)
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::convert",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 287 "Iconv.xs"
      RETVAL = do_conv(self, string);
#line 488 "Iconv.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__IconvPtr_retval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_retval)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Text__Iconv *	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::retval",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 295 "Iconv.xs"
      RETVAL = self->retval;
#line 521 "Iconv.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__IconvPtr_raise_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_raise_error)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Text__Iconv *	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::raise_error",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 303 "Iconv.xs"
      if (items > 1 && SvIOK(ST(1)))
      {
         sv_setiv(self->raise_error, SvIV(ST(1)));
      }
      XPUSHs(sv_mortalcopy(self->raise_error));
#line 560 "Iconv.c"
	PUTBACK;
	return;
    }
}

#if _LIBICONV_VERSION >= 0x0109
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Text__IconvPtr_get_attr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_get_attr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, request");
    {
	Text__Iconv *	self;
	char *	request = (char *)SvPV_nolen(ST(1))
;
#line 316 "Iconv.xs"
      int reqno;
      int arg;
      int err;
#line 584 "Iconv.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::get_attr",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 320 "Iconv.xs"
      if (strEQ(request, "trivialp"))
	 reqno = ICONV_TRIVIALP;
      else if (strEQ(request, "transliterate"))
	 reqno = ICONV_GET_TRANSLITERATE;
      else if (strEQ(request, "discard_ilseq"))
	 reqno = ICONV_GET_DISCARD_ILSEQ;
      else
	 reqno = -1;

      err = do_iconvctl(self, reqno, &arg);

      if (err < 0)
         RETVAL = err;
      else
         RETVAL = arg;
#line 617 "Iconv.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Text__IconvPtr_get_attr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_get_attr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, request");
    {
	Text__Iconv *	self;
	char *	request = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::get_attr",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 345 "Iconv.xs"
     not_here("iconvctl (needed for get_attr())");
     RETVAL = -1;
#line 657 "Iconv.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#if _LIBICONV_VERSION >= 0x0109
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Text__IconvPtr_set_attr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_set_attr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, request, arg");
    {
	Text__Iconv *	self;
	char *	request = (char *)SvPV_nolen(ST(1))
;
	int	arg = (int)SvIV(ST(2))
;
#line 360 "Iconv.xs"
      int reqno;
      int err;
#line 684 "Iconv.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::set_attr",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 363 "Iconv.xs"
      if (strEQ(request, "transliterate"))
	 reqno = ICONV_SET_TRANSLITERATE;
      else if (strEQ(request, "discard_ilseq"))
	 reqno = ICONV_SET_DISCARD_ILSEQ;
      else
	 reqno = -1;

      err = do_iconvctl(self, reqno, &arg);

      if (err < 0)
         RETVAL = err;
      else
         RETVAL = arg;
#line 715 "Iconv.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Text__IconvPtr_set_attr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_set_attr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, request, arg");
    {
	Text__Iconv *	self;
	char *	request = (char *)SvPV_nolen(ST(1))
;
	int	arg = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::IconvPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Text::IconvPtr::set_attr",
			"self", "Text::IconvPtr",
			refstr, ST(0)
		);
	}
;
#line 387 "Iconv.xs"
     not_here("iconvctl (needed for set_attr())");
     RETVAL = -1;
#line 757 "Iconv.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Text__IconvPtr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__IconvPtr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Text__Iconv *	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Text::IconvPtr::DESTROY",
			"self")
;
#line 398 "Iconv.xs"
      /* printf("Now in Text::Iconv::DESTROY\n"); */
      (void) iconv_close(self->handle);
      Safefree(self);
#line 788 "Iconv.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Text__Iconv); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__Iconv)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Text::Iconv::raise_error", XS_Text__Iconv_raise_error, file, ";@");
        (void)newXSproto_portable("Text::Iconv::new", XS_Text__Iconv_new, file, "$$$");
        (void)newXSproto_portable("Text::IconvPtr::convert", XS_Text__IconvPtr_convert, file, "$$");
        (void)newXSproto_portable("Text::IconvPtr::retval", XS_Text__IconvPtr_retval, file, "$");
        (void)newXSproto_portable("Text::IconvPtr::raise_error", XS_Text__IconvPtr_raise_error, file, "$;@");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Text::IconvPtr::get_attr", XS_Text__IconvPtr_get_attr, file, "$$");
#endif
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Text::IconvPtr::get_attr", XS_Text__IconvPtr_get_attr, file, "$$");
#endif
#if XSubPPtmpAAAC
        (void)newXSproto_portable("Text::IconvPtr::set_attr", XS_Text__IconvPtr_set_attr, file, "$$$");
#endif
#if XSubPPtmpAAAD
        (void)newXSproto_portable("Text::IconvPtr::set_attr", XS_Text__IconvPtr_set_attr, file, "$$$");
#endif
        (void)newXSproto_portable("Text::IconvPtr::DESTROY", XS_Text__IconvPtr_DESTROY, file, "$");

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#line 850 "Iconv.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
